<?php
spl_autoload_register(static function ($class) {
    if (class_exists($class, false)) {
        return false;
    }

    if (strpos($class, 'vipclient') !== 0) {
        return false;
    }

    $pathRoot = dirname(__DIR__) . DIRECTORY_SEPARATOR;
    $classFilePath = $pathRoot .
        trim(str_replace('\\', DIRECTORY_SEPARATOR, $class), DIRECTORY_SEPARATOR) .
        '.php';

    if ((file_exists($classFilePath) === false) || (is_readable($classFilePath) === false)) {
        return false;
    }

    require($classFilePath);
});