<?php


namespace vipclient\order;


use vipclient\BaseObject;

/**
 * Class ExtraService
 *
 * @package vipclient\order
 * @property string $code
 * @property string $titleRu
 * @property string $titleEn
 * @property string|null $unitRu
 * @property string|null $unitEn
 * @property bool $customerText
 * @property bool $customerCount
 * @property array|ExtraService[]|null $child
 */
class ExtraService extends BaseObject
{
    /** @var string */
    protected $code;
    /** @var string */
    protected $titleRu;
    /** @var string */
    protected $titleEn;
    /** @var string|null */
    protected $unitRu;
    /** @var string|null */
    protected $unitEn;
    /** @var bool */
    protected $customerText = false;
    /** @var bool */
    protected $customerCount = false;
    /** @var array|self[]|null */
    protected $child;

    /**
     * @return string
     */
    protected function getCode()
    {
        return $this->code;
    }

    /**
     * @return string
     */
    protected function getTitleRu()
    {
        return $this->titleRu;
    }

    /**
     * @return string
     */
    protected function getTitleEn()
    {
        return $this->titleEn;
    }

    /**
     * @return string|null
     */
    protected function getUnitRu()
    {
        return $this->unitRu;
    }

    /**
     * @return string|null
     */
    protected function getUnitEn()
    {
        return $this->unitEn;
    }

    /**
     * @return bool
     */
    protected function getCustomerText()
    {
        return $this->customerText;
    }

    /**
     * @return bool
     */
    protected function getCustomerCount()
    {
        return $this->customerCount;
    }

    /**
     * @return array|ExtraService[]|null
     */
    protected function getChild()
    {
        return $this->child;
    }

    /**
     * @param string $value
     */
    protected function setCode($value)
    {
        $this->code = $value;
    }

    /**
     * @param string $value
     */
    protected function setTitleRu($value)
    {
        $this->titleRu = $value;
    }

    /**
     * @param string $value
     */
    protected function setTitleEn($value)
    {
        $this->titleEn = $value;
    }

    /**
     * @param string|null $value
     */
    protected function setUnitRu($value)
    {
        $this->unitRu = $value;
    }

    /**
     * @param string|null $value
     */
    protected function setUnitEn($value)
    {
        $this->unitEn = $value;
    }

    /**
     * @param bool $value
     */
    protected function setCustomerText($value)
    {
        $this->customerText = $value;
    }

    /**
     * @param bool $value
     */
    protected function setCustomerCount($value)
    {
        $this->customerCount = $value;
    }

    /**
     * @param array|null $value
     */
    protected function setChild($value)
    {
        $this->child = $value;
    }

    /**
     * @param ExtraService $value
     */
    public function addChild(ExtraService $value)
    {
        $this->child[] = $value;
    }

    /**
     * @param array $data
     */
    public function load(array $data)
    {
        $data['titleRu'] = $data['title_ru'];
        $data['titleEn'] = $data['title_en'];
        $data['unitRu'] = $data['unit_ru'];
        $data['unitEn'] = $data['unit_en'];
        $data['customerText'] = $data['customer_text'];
        $data['customerCount'] = $data['customer_count'];
        parent::load($data);
        if (array_key_exists('child', $data) && is_array($data['child'])) {
            $this->child = [];
            foreach ($data['child'] as $item) {
                $extraService = new self();
                $extraService->load($item);
                $this->child[] = $extraService;
            }
        }
    }


}