<?php


namespace vipclient\order;


use vipclient\BaseObject;

/**
 * Class OrderExtraService
 *
 * @package vipclient\order
 * @property string $code
 * @property string|null $customerText
 * @property int|null $customerCount
 * @property array|ExtraService[]|null $child
 */
class OrderExtraService extends BaseObject
{
    /** @var string */
    protected $code;
    /** @var string|null */
    protected $customerText;
    /** @var int|null */
    protected $customerCount;
    /** @var array|self[]|null */
    protected $child;

    /**
     * @return string
     */
    protected function getCode()
    {
        return $this->code;
    }

    /**
     * @return string|null
     */
    protected function getCustomerText()
    {
        return $this->customerText;
    }

    /**
     * @return int|null
     */
    protected function getCustomerCount()
    {
        return $this->customerCount;
    }

    /**
     * @return array|ExtraService[]|null
     */
    protected function getChild()
    {
        return $this->child;
    }

    /**
     * @param string $value
     */
    protected function setCode($value)
    {
        $this->code = $value;
    }

    /**
     * @param string|null $value
     */
    protected function setCustomerText($value)
    {
        $this->customerText = $value;
    }

    /**
     * @param int|null $value
     */
    protected function setCustomerCount($value)
    {
        $this->customerCount = $value;
    }

    /**
     * @param array|null $value
     */
    protected function setChild($value)
    {
        $this->child = $value;
    }

    /**
     * @param OrderExtraService $value
     */
    public function addChild(OrderExtraService $value)
    {
        $this->child[] = $value;
    }

    /**
     * @param string $code
     * @return OrderExtraService|null
     */
    public function getChildByCode($code)
    {
        $result = null;
        /** @var self $child */
        foreach ($this->child as $child) {
            if ($child->code === $code) {
                $result = $child;
                break;
            }
        }
        return $result;
    }
}