<?php


namespace vipclient\order;


use vipclient\BaseObject;
use vipclient\exceptions\ExceptionData;

/**
 * Class OrderFlightData
 *
 * @package vipclient\order
 * @property string $terminal;
 * @property string $direction;
 * @property string $date;
 * @property string $time;
 * @property string $number;
 * @property string $way;
 */
class OrderFlightData extends BaseObject
{
    /** @var string */
    protected $terminal;
    /** @var string */
    protected $direction;
    /** @var string */
    protected $date;
    /** @var string */
    protected $time;
    /** @var string */
    protected $number;
    /** @var string */
    protected $way;

    /**
     * @return string
     */
    protected function getTerminal()
    {
        return $this->terminal;
    }

    /**
     * @return string
     */
    protected function getDirection()
    {
        return $this->direction;
    }

    /**
     * @return string
     */
    protected function getDate()
    {
        return $this->date;
    }

    /**
     * @return string
     */
    protected function getTime()
    {
        return $this->time;
    }

    /**
     * @return string
     */
    protected function getNumber()
    {
        return $this->number;
    }

    /**
     * @return string
     */
    protected function getWay()
    {
        return $this->way;
    }

    /**
     * @param string $value
     */
    protected function setTerminal($value)
    {
        $this->terminal = strtoupper(trim($value));
    }

    /**
     * @param string $value
     * @throws ExceptionData
     */
    protected function setDirection($value)
    {
        $value = strtolower(trim($value));
        if (!in_array($value, ['arrival', 'departure'])) {
            throw new ExceptionData('Not valid value for direction');
        }
        $this->direction = $value;
    }

    /**
     * @param string $value
     */
    protected function setDate($value)
    {
        $this->date = $value;
    }

    /**
     * @param string $value
     */
    protected function setTime($value)
    {
        $this->time = $value;
    }

    /**
     * @param string $value
     */
    protected function setNumber($value)
    {
        $this->number = $value;
    }

    /**
     * @param string $value
     */
    protected function setWay($value)
    {
        $this->way = $value;
    }
}